/*
=========================================================================
	OGCOMBAT.H
    Superstructure for simulating Open Gaming RPG fights.
	Copyright (c) 2007 by Daniel R. Collins. All rights reserved.
  May be distributed under the terms of GPL version 2 (see Copying.txt).
=========================================================================
*/

#ifndef _OGCOMBAT_H
#define _OGCOMBAT_H

#include "creature.h"

class OGCombat {
public:
  // Enumerations
  enum InContactEnum { enemiesInContact = 5 };

  // Constructors
  OGCombat (const char *heroDesc, const char *enemyDesc, int enemies, int category);
  OGCombat (int ftrLevel, const char *enemyDesc, int enemies, int category);
  ~OGCombat (void);

  // Mutators
  int fight (int numberCombats);

protected:
  int oneCombat();
  void heroAttacks();
  void enemyAttacks();
  int enemiesInRange();
  int enemiesKilled();

private:
  Creature *hero, **enemy;
  const char *heroDesc, *enemyDesc;
  int category, enemies;
};

#endif

