/*
=========================================================================
	WEAPON.H
    Interface to the Weapon class (attack routines).
	Copyright (c) 2004-2007 by Daniel R. Collins. All rights reserved.
  May be distributed under the terms of GPL version 2 (see Copying.txt).
=========================================================================
*/

#ifndef _WEAPON_H
#define _WEAPON_H

#include <string>
using namespace std;
#include "dice.h"


class Weapon {
public:
  // Enumerations
  enum CategoryEnum { melee, ranged };
  enum ProficiencyEnum { simple, martial, exotic };
  enum TypeEnum { bludgeoning, piercing, slashing };

  // Constructors
  Weapon (const char *data);

  // Accessors
  int getNumAttacks (void);

  // Attack rolls (return damage)
  int oneAttack (int num, int AC, int atkMod, int crit = 0);
  int fullAttack (int AC, int atkMod);

protected:
  int getAttackBonus (int num);

private:
  string name;
  bool natural;
  int numAttacks;
  int primaryBonus;
  int critRange, critMult;
  Dice damage;
};


#endif

